;%include "asm.inc"
%define classname CUDPMessage
%include "class.inc"

global CUDPMessage_vtable_

%define FIONREAD    1074030207
%define IPPROTO_UDP 17
%define INFINITE    -1
%define AF_INET     2

struc sCUDPMessage
.vtable  resd 1
.m_sock  resd 1
.temp    resd 1
.m_thre  resb 1
endstruc

//%define makeip(r,e,w,q) ((q<<24)|(w<<16)|(e<<8)|r)

INTERFACE CUDPMessage
	STDMETHOD SendTo
	STDMETHOD OnDataArrival
ENDINTERFACE

segment .data
CUDPMessage_vtable_:
	dd CUDPMessage@SendTo
	dd CUDPMessage@OnDataArrival
segment .text

//---------------------------------------------
METHOD CUDPMessage, 0 uses esi
	mov    esi,400
	sub    esp,esi
	invoke WSAStartup, 0x202, esp
	add    esp,esi
	mov    eax,2    // AF_INET = SOCK_DGRAM = 2
	invoke socket, eax, eax, IPPROTO_UDP
	mov    member(m_sock),eax
	sub    edx,edx
	mov    member(m_thre),edx
ENDMETHOD


//---------------------------------------------
METHOD _CUDPMessage, 0
	mov    eax,member(m_sock)
	inc    eax
	jz    _q0
	dec    eax
	invoke closesocket, eax
	mov    dword member(m_sock),-1
_q0:
	invoke WSACleanup
	// wait for thread
	mov    eax,member(m_thre)
	and    eax,eax
	jz    _q1
	invoke WaitForSingleObject, eax, INFINITE
	invoke CloseHandle, member(m_thre)
_q1:
ENDMETHOD


//---------------------------------------------
METHOD ThreadProc, 0
	alloca 8+8 // fd_set + timeval

_do
	mov    eax,member(m_sock)
	inc    eax
	jz    _q2
	dec    eax
	mov    edx,1
	mov    dword[esp   ],edx // fd_set.fd_count
	mov    dword[esp+ 4],eax // fd_set.fd_array
	mov    dword[esp+ 8],edx // timeval.tv_sec
	mov    dword[esp+12],edx // timeval.tv_usec

	sub    edx,edx
	mov    eax,esp     // fd_set
	lea    ecx,[esp+8] // timeval
	invoke select, 0, eax, edx, edx, ecx
	cmp    eax,0
	jz    _do        // timeout
	jg    _ok1       // has data
	invoke Sleep, 10 // SOCKET_ERROR
	jmp   _do
_ok1:
	dec    eax
	jnz   _do

	invoke  ioctlsocket, member(m_sock), FIONREAD, esp
	call    CUDPMessage@Recv, this, [esp]
	jmp    _do
_q2:
	invoke ExitThread, 0
ENDMETHOD


//---------------------------------------------
METHOD SendTo, 4 // ip, port, data, cb
	alloca 16
	mov    edx,arg(0) // ip
	mov    eax,arg(1) // port

	sub    ecx,ecx
	bswap  eax
	mov    ax, AF_INET
	mov    [esp],eax    // sin_family, sin_port
	mov    [esp+ 4],edx // sin_addr
	mov    [esp+ 8],ecx // sin_zero
	mov    [esp+12],ecx // sin_zero
	mov    eax,esp
	invoke sendto, member(m_sock), arg(2,4), arg(3,3), ecx, eax, 16
ENDMETHOD


//---------------------------------------------
METHOD Bind, 2 // ip, port
	alloca 16

	mov   edx,arg(0) // ip
	mov   eax,arg(1) // port
	xor   ecx,ecx
	bswap eax
	mov   ax, AF_INET
	mov   [esp],eax    // sin_family, sin_port
	mov   [esp+ 4],edx // sin_addr
	mov   [esp+ 8],ecx // sin_zero
	mov   [esp+12],ecx // sin_zero
	mov   eax,esp
	invoke bind, member(m_sock), eax, 16
	and    eax,eax
	jnz   _q4
	invoke CreateThread, eax, eax, CUDPMessage@ThreadProc, this, eax, esp
	mov    member(m_thre),eax
	sub    eax,eax
_q4
ENDMETHOD


//---------------------------------------------
METHOD Recv, 1 uses esi,edi,ebx // cb
	mov  esi,esp    // saved esp
	mov  ebx,arg(0) // len
	and  ebx,0FFFFh
	mov  edi,ebx
	add  edi,21     // stackframe
	sub  esp,edi
	and  sp,~3        // align esp to DWORD
	lea  ecx,[esp+ 4] // sockaddr_in*
	lea  edx,[esp+20] // buffer
	mov  dword[esp],16// fromlen

	invoke recvfrom, member(m_sock),edx,ebx,0,ecx,esp

	cmp  eax,0
	jng _q6
	lea  edx,[esp+20] // buffer
	lea  ecx,[esp+ 4] // sockaddr_in*
	mov  byte[edx+eax],0
	%define coinvoke_reg
	coinvoke this, CUDPMessage_OnDataArrival, [ecx+4], edx, ebx // ip, buff, cb
_q6:

	mov  esp,esi
ENDMETHOD


//---------------------------------------------
METHOD OnDataArrival, 3 // ip, buff, cb

ENDMETHOD
