#ifndef __tools_gui_inc__
#define __tools_gui_inc__

#use "CUDPMessage.lib"

/*
sub CUDPMessage
*/
class CUDPMessage
{
	declare CUDPMessage();

	// destructor closes socket and waits for thread
	declare _CUDPMessage();

	// sends data to a server (ip as in_addr)
	// returns number of bytes sent, or -1 on error
	declare virtual SendTo(int ip,int port, void* data,int cb),int;

	// for servers: call Bind to receive messages. (ip as in_addr)
	// returns 0 on success
	declare Bind(int ip,int port),int;

	// called after data has been received. The buffer is always NULL terminated
	// but cb doesn't include this character. (ip as in_addr)
	// 16 bytes bellow pData is sender's sockaddr_in structure
	// sockaddr_in* sender = pData-16;
	declare virtual OnDataArrival(int ip, byte* pData, int cb);

//private:
	// waits for data on bound socket
	declare ThreadProc();
	// receives data and calls OnDataArrival
	declare Recv(int bytes),int;

	int m_socket;
	int m_reserved;
	int m_hThread;
}
#endif
