// contents of fsplugin.h  version 1.5 (21.Nov.2005)

/* required
export FsInit;
export FsFindFirst;
export FsFindNext;
export FsFindClose;
export FsGetDefRootName;
*/
// ids for FsGetFile
#define FS_FILE_OK 0
#define FS_FILE_EXISTS 1
#define FS_FILE_NOTFOUND 2
#define FS_FILE_READERROR 3
#define FS_FILE_WRITEERROR 4
#define FS_FILE_USERABORT 5
#define FS_FILE_NOTSUPPORTED 6
#define FS_FILE_EXISTSRESUMEALLOWED 7

#define FS_EXEC_OK 0
#define FS_EXEC_ERROR 1
#define FS_EXEC_YOURSELF -1
#define FS_EXEC_SYMLINK -2

#define FS_COPYFLAGS_OVERWRITE 1
#define FS_COPYFLAGS_RESUME 2
#define FS_COPYFLAGS_MOVE 4
#define FS_COPYFLAGS_EXISTS_SAMECASE 8
#define FS_COPYFLAGS_EXISTS_DIFFERENTCASE 16
 
// flags for tRequestProc
#define RT_Other 0
#define RT_UserName 1
#define RT_Password 2
#define RT_Account 3
#define RT_UserNameFirewall 4
#define RT_PasswordFirewall 5
#define RT_TargetDir 6
#define RT_URL 7
#define RT_MsgOK 8
#define RT_MsgYesNo 9
#define RT_MsgOKCancel 10

// flags for tLogProc
#define MSGTYPE_CONNECT 1
#define MSGTYPE_DISCONNECT 2
#define MSGTYPE_DETAILS 3
#define MSGTYPE_TRANSFERCOMPLETE 4
#define MSGTYPE_CONNECTCOMPLETE 5
#define MSGTYPE_IMPORTANTERROR 6
#define MSGTYPE_OPERATIONCOMPLETE 7

// flags for FsStatusInfo
#define FS_STATUS_START 0
#define FS_STATUS_END 1

#define FS_STATUS_OP_LIST 1
#define FS_STATUS_OP_GET_SINGLE 2
#define FS_STATUS_OP_GET_MULTI 3
#define FS_STATUS_OP_PUT_SINGLE 4
#define FS_STATUS_OP_PUT_MULTI 5
#define FS_STATUS_OP_RENMOV_SINGLE 6
#define FS_STATUS_OP_RENMOV_MULTI 7
#define FS_STATUS_OP_DELETE 8
#define FS_STATUS_OP_ATTRIB 9
#define FS_STATUS_OP_MKDIR 10
#define FS_STATUS_OP_EXEC 11
#define FS_STATUS_OP_CALCSIZE 12
#define FS_STATUS_OP_SEARCH 13
#define FS_STATUS_OP_SEARCH_TEXT 14
#define FS_STATUS_OP_SYNC_SEARCH 15
#define FS_STATUS_OP_SYNC_GET 16
#define FS_STATUS_OP_SYNC_PUT 17
#define FS_STATUS_OP_SYNC_DELETE 18

#define FS_ICONFLAG_SMALL 1
#define FS_ICONFLAG_BACKGROUND 2

#define FS_ICON_USEDEFAULT 0
#define FS_ICON_EXTRACTED 1
#define FS_ICON_EXTRACTED_DESTROY 2
#define FS_ICON_DELAYED 3

struct RemoteInfoStruct {
    DWORD SizeLow;
	DWORD SizeHigh;
    FILETIME LastWriteTime;
    int Attr;
} ;

struct FsDefaultParamStruct {
	int size;
	DWORD PluginInterfaceVersionLow;
	DWORD PluginInterfaceVersionHi;
	dstring DefaultIniName[MAX_PATH];
} ;

#ifdef NEVER
// callback functions
d eclare *tProgressProc(int PluginNr,char* SourceName,char* TargetName,int PercentDone),int;
d eclare *tLogProc(int PluginNr,int MsgType,char* LogString);
d eclare *tRequestProc(int PluginNr,int RequestType,char* CustomTitle,char* CustomText,char* ReturnedText,int maxlen),BOOL;


// Function prototypes

// a) Mandatory (must be implemented)
s ub FsInit(int PluginNr, FARPROC pProgressProc,FARPROC pLogProc,FARPROC pRequestProc),int;
s ub FsFindFirst(char* Path,WIN32_FIND_DATA *FindData),HANDLE;
s ub FsFindNext(HANDLE Hdl,WIN32_FIND_DATA *FindData),BOOL;
s ub FsFindClose(HANDLE Hdl),int;

// b) Optional (must NOT be implemented if unsupported!)
s ub FsMkDir(char* Path),BOOL;
s ub FsExecuteFile(HWND MainWin,char* RemoteName,char* Verb),int;
s ub FsRenMovFile(char* OldName,char* NewName,BOOL Move,BOOL OverWrite,RemoteInfoStruct* ri),int;
s ub FsGetFile(char* RemoteName,char* LocalName,int CopyFlags,RemoteInfoStruct* ri),int;
s ub FsPutFile(char* LocalName,char* RemoteName,int CopyFlags),int;
s ub FsDeleteFile(char* RemoteName),BOOL;
s ub FsRemoveDir(char* RemoteName),BOOL;
s ub FsDisconnect(char* DisconnectRoot),BOOL;
s ub FsSetAttr(char* RemoteName,int NewAttr),BOOL;
s ub FsSetTime(char* RemoteName,FILETIME *CreationTime,FILETIME *LastAccessTime,FILETIME *LastWriteTime),BOOL;
s ub FsStatusInfo(char* RemoteDir,int InfoStartEnd,int InfoOperation);
s ub FsGetDefRootName(char* DefRootName,int maxlen);
s ub FsExtractCustomIcon(char* RemoteName,int ExtractFlags,HICON* TheIcon),int;
s ub FsSetDefaultParams(FsDefaultParamStruct* dps);
s ub FsGetPreviewBitmap(char* RemoteName,int width,int height,HBITMAP* ReturnedBitmap),int;
s ub FsLinksToLocalFiles(),BOOL;
s ub FsGetLocalName(char* RemoteName,int maxlen),BOOL;

#endif
// ************************** content plugin extension ****************************

// 
#define ft_nomorefields 0
#define ft_numeric_32 1
#define ft_numeric_64 2
#define ft_numeric_floating 3
#define ft_date 4

#define ft_time 5
#define ft_boolean 6
#define ft_multiplechoice 7
#define ft_string 8
#define ft_fulltext 9
#define ft_datetime 10

// for FsContentGetValue
#define ft_nosuchfield -1   // error, invalid field number given
#define ft_fileerror -2     // file i/o error
#define ft_fieldempty -3    // field valid, but empty
#define ft_ondemand -4      // field will be retrieved only when user presses <SPACEBAR>
#define ft_delayed 0        // field takes a long time to extract -> try again in background

// for FsContentSetValue
#define ft_setsuccess 0     // setting of the attribute succeeded

// for FsContentGetSupportedFieldFlags
#define contflags_edit 1
#define contflags_substsize 2
#define contflags_substdatetime 4
#define contflags_substdate 6
#define contflags_substtime 8
#define contflags_substattributes 10
#define contflags_substattributestr 12
#define contflags_substmask 14

// for FsContentSetValue
#define setflags_first_attribute 1     // First attribute of this file

#define setflags_last_attribute  2     // Last attribute of this file
#define setflags_only_date       4     // Only set the date of the datetime value!


#define CONTENT_DELAYIFSLOW 1  // ContentGetValue called in foreground

struct ContentDefaultParamStruct {
    int size;
    DWORD PluginInterfaceVersionLow;
    DWORD PluginInterfaceVersionHi;
    char DefaultIniName[MAX_PATH];
} ;

struct tdateformat {
	WORD wYear;
	WORD wMonth;
	WORD wDay;
}

struct ttimeformat {
	WORD wHour;
	WORD wMinute;
	WORD wSecond;
}

#ifdef NEVER

s ub FsContentGetSupportedField(int FieldIndex,char* FieldName,char* Units,int maxlen),int;
s ub FsContentGetValue(char* FileName,int FieldIndex,int UnitIndex,void* FieldValue,int maxlen,int flags),int;

s ub FsContentStopGetValue(char* FileName);
s ub FsContentGetDefaultSortOrder(int FieldIndex),int;
s ub FsContentPluginUnloading();
s ub FsContentGetSupportedFieldFlags(int FieldIndex),int;

s ub FsContentSetValue(char* FileName,int FieldIndex,int UnitIndex,int FieldType,void* FieldValue,int flags),int;
s ub FsContentGetDefaultView(char* ViewContents,char* ViewHeaders,char* ViewWidths,char* ViewOptions,int maxlen),BOOL;


#endif
