#include "winsock.inc"
#include "totalcmd\\fsplugin.inc"
#include "tools\\gui.inc"
#include "..\\udpfileenum.inc"

declare extern ShowOptionsDialog(HWND hwndParent);
declare extern LoadSettings();

// tLogProc - send strings to FTP log window
declare import, tLogProc(int PluginNr,int MsgType,char* LogString); // set up in FsInit
extern  __imp_tLogProc as FARPROC;
// tLogProc wrapped for MSGTYPE_IMPORTANTERROR
declare extern FtpLog(...);


extern g_ServerPort  as int;
extern g_IniFilePath as string;
extern g_UseFtpLog   as BOOL;
extern g_PluginNr    as int;

extern g_TimeoutBroadcast as int;
extern g_TimeoutBrowsing as int;
extern g_TimeoutDelete as int;
extern g_TimeoutMove as int;
extern g_TimeoutUpload as int;
extern g_TimeoutDownload as int;
extern g_TimeoutExecute as int;
extern g_TimeoutCreateDir as int;
extern g_TimeoutRemoveDir as int;
extern g_TimeoutSetAttributes as int;
extern g_TimeoutSetTime as int;


// base class
class CRemote : CUDPMessage
{
	declare  CRemote();
	declare _CRemote();

	declare GetSocketPort(),int;
	declare WaitForSingleObject(HANDLE hHandle, DWORD dwMilliseconds),DWORD;
	declare virtual FsFindNext(WIN32_FIND_DATA *FindData),BOOL;
	//
	// required properties
	//
	int       m_server_ip;
	int       m_server_port;
	int       m_timeout;
	HANDLE    m_hEvent;
}



// FsFindFirst("\\")
class CEnumRunning : CRemote
{
	declare  CEnumRunning();
	declare _CEnumRunning();

	declare GetRunning();
	declare virtual FsFindNext(WIN32_FIND_DATA *FindData),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	BOOL          m_wait;
	CPointerList  m_iplist; // STARTUPTIME
	_linked_list *m_pos;
}



// FsFindFirst("\\12.345.67.89")
class CEnumDrives : CRemote
{
	declare  CEnumDrives();

	declare GetDrives();
	declare virtual FsFindNext(WIN32_FIND_DATA *FindData),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	DWORD m_drivebits;
	UCHAR m_driveletter;
}


// FsFindFirst("\\12.345.67.89\\c")
class CEnumFiles : CRemote
{
	declare  CEnumFiles();
	declare _CEnumFiles();

	declare GetFiles(string *path);
	declare virtual FsFindNext(WIN32_FIND_DATA *FindData),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	BOOL          m_wait;
	CPointerList  m_filelist; // ENUMFILES_REPLY
	_linked_list *m_pos;
}


class CDownloader : CRemote
{
	declare CDownloader();
	declare GetDownloadPort(string *path, int *ppPort, LARGE_INTEGER *pFileSize),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CUploader : CRemote
{
	declare CUploader();
	declare GetUploadPort(string *path, DWORD dwCreationDisposition, int *ppPort, LARGE_INTEGER *pFileSize, DWORD *ppError),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


// to do: move the calls from wfxvpc.src
class CRenMovFile : CRemote
{
	declare CRenMovFile();
	declare RenMovFile(string* OldName, string* NewName, BOOL Move, BOOL OverWrite, HANDLE *pphThread, DWORD *ppError),BOOL;
	declare WaitForCompletion(string* OldName, string* NewName, FARPROC ProgressProc, HANDLE hThread),int;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CExecuter : CRemote
{
	declare  CExecuter();
	declare _CExecuter();
	declare Execute(string *verb, string *file,opt string *parameters = NULL),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T *m_packet; // unknown size
}


class CMkDir : CRemote
{
	declare CMkDir();
	declare CreateDirectory(string *dir),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CRemoveDir : CRemote
{
	declare CRemoveDir();
	declare RemoveDir(string *dir),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CDeleteFile : CRemote
{
	declare CDeleteFile();
	declare DeleteFile(string *path),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CAttributes : CRemote
{
	declare CAttributes();
	declare SetAttributes(string* FilePath,int NewAttr),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CSetFileTime : CRemote
{
	declare CSetFileTime();
	declare SetTimes(string* FilePath,FILETIME *CreationTime, FILETIME *LastAccessTime,FILETIME *LastWriteTime),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	PACKET_T m_packet;
}


class CGetIcon : CRemote
{
	declare CGetIcon();
	declare GetIcon(string* FilePath,int index,HICON *ppv),BOOL;
	declare virtual OnDataArrival(int ip, PACKET_T* pData, int cb);

	HICON m_icon;
	PACKET_T m_packet;
}
